using System.Text.Json;
using System.Text.Json.Serialization;

namespace File_Watcher.Models;

public record SerialConfiguration(string Destination,
                                  string GhostPCLFileName,
                                  string LincPDFCFileName,
                                  string PortName)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, SerialConfigurationSourceGenerationContext.Default.SerialConfiguration);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(SerialConfiguration))]
internal partial class SerialConfigurationSourceGenerationContext : JsonSerializerContext
{
}